#pragma semicolon 1
#define DEBUG
#define PLUGIN_AUTHOR "jenz"
#define PLUGIN_VERSION "1.00"
#include <sourcemod>
#include <sdktools>
#include <unloze_zones>
#pragma newdecls required
static Handle g_hAntiZones;
public Plugin myinfo = 
{
	name = "unloze racetimer antizones",
	author = PLUGIN_AUTHOR,
	description = "disables timers in case route is considered forbidden",
	version = PLUGIN_VERSION,
	url = "www.unloze.com"
};
//----------------------------------------------------------------------------------------------------
// Purpose: 
//----------------------------------------------------------------------------------------------------
public APLRes AskPluginLoad2(Handle myself, bool late, char [] error, int err_max)
{
	g_hAntiZones = CreateGlobalForward("CheckifAntiZones", ET_Ignore, Param_Cell, Param_Cell);
	return APLRes_Success;
}
//----------------------------------------------------------------------------------------------------
// Purpose: 
//----------------------------------------------------------------------------------------------------
public void unloze_zoneEntry(int client, char[] zone)
{
	if (StrContains(zone, "ZONE_PREFIX_ANTI") > -1)
	{
		Call_StartForward(g_hAntiZones);
		Call_PushCell(client);
		Call_PushCell(1);
		Call_Finish();
	}
}
//----------------------------------------------------------------------------------------------------
// Purpose: 
//----------------------------------------------------------------------------------------------------
public void OnPluginEnd()
{
	CloseHandle(g_hAntiZones);
}
//----------------------------------------------------------------------------------------------------
// Purpose: 
//----------------------------------------------------------------------------------------------------